<?php

add_action( 'after_setup_theme', 'blankslate_setup' );
function blankslate_setup()
{
load_theme_textdomain( 'blankslate', get_template_directory() . '/languages' );
add_theme_support( 'title-tag' );
add_theme_support( 'automatic-feed-links' );
add_theme_support( 'post-thumbnails' );
global $content_width;
if ( ! isset( $content_width ) ) $content_width = 640;

register_nav_menus(
array( 'main-menu' => __( 'Main Menu', 'blankslate' ) )
);
}

add_action( 'widgets_init', 'blankslate_widgets_init' );
function blankslate_widgets_init()
{
register_sidebar( array (
'name' => __( 'Sidebar Widget Area', 'blankslate' ),
'id' => 'primary-widget-area',
'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
'after_widget' => "</li>",
'before_title' => '<h3 class="widget-title">',
'after_title' => '</h3>',
) );
}




// Call Googles HTML5 Shim, but only for users on old versions of IE
function wpfme_IEhtml5_shim () {
	global $is_IE;
	if ($is_IE)
	echo '<!--[if lt IE 9]><script src="http://html5shim.googlecode.com/svn/trunk/html5.js"></script><![endif]-->';
}
add_action('wp_head', 'wpfme_IEhtml5_shim');


// Remove the version number of WP
// Warning - this info is also available in the readme.html file in your root directory - delete this file!
remove_action('wp_head', 'wp_generator');


// Obscure login screen error messages
function wpfme_login_obscure(){ return '<strong>Sorry</strong>: Think you have gone wrong somwhere!';}
add_filter( 'login_errors', 'wpfme_login_obscure' );


// Disable the theme / plugin text editor in Admin
define('DISALLOW_FILE_EDIT', true);

// remove wp version param from any enqueued scripts
add_filter( 'style_loader_src',  'sdt_remove_ver_css_js', 9999, 2 );
add_filter( 'script_loader_src', 'sdt_remove_ver_css_js', 9999, 2 );
function sdt_remove_ver_css_js( $src, $handle ) 
{
    $handles_with_version = [ 'style' ]; // <-- Adjust to your needs!

    if ( strpos( $src, 'ver=' ) && ! in_array( $handle, $handles_with_version, true ) )
        $src = remove_query_arg( 'ver', $src );

    return $src;
}

// REMOVE WP-JSON
remove_action( 'wp_head',      'rest_output_link_wp_head'              );
remove_action( 'wp_head',      'wp_oembed_add_discovery_links'         );
remove_action( 'template_redirect', 'rest_output_link_header', 11 );

// Remove login by mail
remove_filter( 'authenticate', 'wp_authenticate_email_password', 20 );

//Disable RSS
function fb_disable_feed() {
wp_die( __('No feed available,please visit our <a href="'. get_bloginfo('url') .'">homepage</a>!') );
}
 
add_action('do_feed', 'fb_disable_feed', 1);
add_action('do_feed_rdf', 'fb_disable_feed', 1);
add_action('do_feed_rss', 'fb_disable_feed', 1);
add_action('do_feed_rss2', 'fb_disable_feed', 1);
add_action('do_feed_atom', 'fb_disable_feed', 1);

// Remove welcome panel dashboard
remove_action('welcome_panel', 'wp_welcome_panel');

// Remove faille XML
add_filter('xmlrpc_enabled', '__return_false');

// Remove WP EMOJI
function disable_wp_emojicons() {
  // all actions related to emojis
  remove_action( 'admin_print_styles', 'print_emoji_styles' );
  remove_action( 'wp_head', 'print_emoji_detection_script', 7 );
  remove_action( 'admin_print_scripts', 'print_emoji_detection_script' );
  remove_action( 'wp_print_styles', 'print_emoji_styles' );
  remove_filter( 'wp_mail', 'wp_staticize_emoji_for_email' );
  remove_filter( 'the_content_feed', 'wp_staticize_emoji' );
  remove_filter( 'comment_text_rss', 'wp_staticize_emoji' );

  // filter to remove TinyMCE emojis
  add_filter( 'tiny_mce_plugins', 'disable_emojicons_tinymce' );
}


// Disable EMOJI
function disable_emojicons_tinymce( $plugins ) {
  if ( is_array( $plugins ) ) {
    return array_diff( $plugins, array( 'wpemoji' ) );
  } else {
    return array();
  }
}

add_filter( 'emoji_svg_url', '__return_false' );
add_action( 'init', 'disable_wp_emojicons' );




/////////////////////////////////////////////////////////////////////
////////// Ajout des styles et des scripts
////////////////////////////////////////////////////////////////////

/////////* Call the google CDN version of jQuery for the frontend
        // Make sure you use this with wp_enqueue_script('jquery'); in your header
        function wpfme_jquery_enqueue() {
          wp_deregister_script('jquery');
          wp_register_script('jquery', "https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js", true, null);
          wp_enqueue_script('jquery');
        }
        if (!is_admin()) add_action("wp_enqueue_scripts", "wpfme_jquery_enqueue", 11);

/////////* Enregistrement des js en footer
        function dataprojekt_footer_script()
        {
            if ($GLOBALS['pagenow'] != 'wp-login.php' && !is_admin()) {

                wp_register_script('datageneraljs', get_template_directory_uri() . '/assets/js/jquery.smoothState.min.js', array('jquery'), '1.0.0', true);
                wp_enqueue_script('datageneraljs');

                wp_register_script('lightsliderjs', get_template_directory_uri() . '/assets/js/lightslider.min.js', array('jquery'), '1.0.0', true); // Custom scripts
                wp_enqueue_script('lightsliderjs'); // Enqueue it!

                wp_register_script('lightgalleryjs', get_template_directory_uri() . '/assets/js/lightgallery-all.min.js', array('jquery'), '1.0.0', true); // Custom scripts
                wp_enqueue_script('lightgalleryjs'); // Enqueue it!

                wp_register_script('waypointsjs', get_template_directory_uri() . '/assets/js/jquery.waypoints.min.js', array('jquery'), '1.0.0', true); // Custom scripts
                wp_enqueue_script('waypointsjs'); // Enqueue it!

                wp_register_script('flatpickr', 'https://npmcdn.com/flatpickr/dist/flatpickr.min.js', array('jquery'), '1.0.0', true); // Custom scripts
                wp_enqueue_script('flatpickr'); // Enqueue it!

                wp_register_script('flatpickrFR', 'https://npmcdn.com/flatpickr/dist/l10n/fr.js', array('jquery'), '1.0.0', true); // Custom scripts
                wp_enqueue_script('flatpickrFR'); // Enqueue it!


                wp_register_script('datajs', get_template_directory_uri() . '/assets/js/data.js', array('jquery'), '1.0.0', true); // Custom scripts
                wp_enqueue_script('datajs'); // Enqueue it!

            }
        }
        add_action('init', 'dataprojekt_footer_script'); // Add Custom Scripts to wp_head


/////////* Enregistrement des css en header
          function dataprojekt_header_style()
          {
              wp_register_style('normalize', get_template_directory_uri() . '/assets/css/normalize.css', array(), '', 'all', true);
              wp_enqueue_style('normalize'); // Enqueue it!

              wp_register_style('lightslider', get_template_directory_uri() . '/assets/css/lightslider.min.css', array(), '', 'all', true);
              wp_enqueue_style('lightslider'); // Enqueue it!

              wp_register_style('lightgallery', get_template_directory_uri() . '/assets/css/lightgallery.min.css', array(), '', 'all', true);
              wp_enqueue_style('lightgallery'); // Enqueue it!

              wp_register_style('flatpickr', 'https://npmcdn.com/flatpickr/dist/flatpickr.min.css', array(), '', 'all', true);
              wp_enqueue_style('flatpickr'); // Enqueue it!

              wp_register_style('webflowcss', get_template_directory_uri() . '/assets/css/webflow.css', array(), '', 'all', true);
              wp_enqueue_style('webflowcss'); // Enqueue it!

              wp_register_style('styles', get_template_directory_uri() . '/assets/css/faktory.css', array(), '', 'all', true);
              wp_enqueue_style('styles'); // Enqueue it!

              wp_register_style('font-weight', get_template_directory_uri() . '/assets/css/font-weight.css', array(), '', 'all', true);
              wp_enqueue_style('font-weight'); // Enqueue it!

              wp_register_style('datacss', get_template_directory_uri() . '/assets/css/data.css', array(), '', 'all', true);
              wp_enqueue_style('datacss'); // Enqueue it!

              wp_register_style('morecss', get_template_directory_uri() . '/assets/css/more-styles.css', array(), '', 'all', true);
              wp_enqueue_style('morecss'); // Enqueue it!
          }
          add_action('wp_enqueue_scripts', 'dataprojekt_header_style'); // Add Theme Stylesheet



/////////////////////////////////////////////////////////////////////
////////// Ajout des pages d'options du theme > ACF
////////////////////////////////////////////////////////////////////

if( function_exists('acf_add_options_page') ) {
  
        // add parent
        $parent = acf_add_options_page(array(
          'menu_title'  => 'Faktory Options',
          'redirect'    => true
        ));

        // add sub page
        acf_add_options_sub_page(array(
          'page_title'  => 'Header',
          'menu_title'  => 'Header',
          'parent_slug'   => $parent['menu_slug'],
        ));

        // add sub page
        acf_add_options_sub_page(array(
          'page_title'  => 'Footer',
          'menu_title'  => 'Footer',
          'parent_slug'   => $parent['menu_slug'],
        ));

        // add sub page
        acf_add_options_sub_page(array(
            'page_title'  => 'Général',
            'menu_title'  => 'Général',
            'parent_slug'   => $parent['menu_slug'],
            'capability' => 'administrator'
        ));
		
        // add sub page
        acf_add_options_sub_page(array(
          'page_title'  => 'Favicons',
          'menu_title'  => 'Favicons',
          'parent_slug'   => $parent['menu_slug'],
          'capability' => 'administrator'
        ));
		
		function add_custom_option_page() {
			add_submenu_page( 
				'', 
				'Favicons', 
				'Favicons',
				'manage_options', 
				'acf-options-favicons', 
				'favicons_callback'
			);
		}
		add_action('admin_menu', 'add_custom_option_page');
        
      }

/////////////////////////////////////////////////////////////////////
////////// Customisation de l'Admin
////////////////////////////////////////////////////////////////////

      function dimox_breadcrumbs(){
        /* === OPTIONS === */
        $text['home']     = 'Accueil'; // text for the 'Home' link
        $text['category'] = 'Archive by Category "%s"'; // text for a category page
        $text['tax']    = 'Archive for "%s"'; // text for a taxonomy page
        $text['search']   = 'Recherche pour "%s"'; // text for a search results page
        $text['tag']      = 'Posts Tagged "%s"'; // text for a tag page
        $text['author']   = 'Articles Posted by %s'; // text for an author page
        $text['404']      = 'Page introuvable'; // text for the 404 page
        $showCurrent = 1; // 1 - show current post/page title in breadcrumbs, 0 - don't show
        $showOnHome  = 0; // 1 - show breadcrumbs on the homepage, 0 - don't show
        $delimiter   = ' / '; // delimiter between crumbs
        $before      = '<span class="current">'; // tag before the current crumb
        $after       = '</span>'; // tag after the current crumb
        /* === END OF OPTIONS === */
        global $post;
        $homeLink = get_bloginfo('url') . '/';
        $linkBefore = '<span typeof="v:Breadcrumb">';
        $linkAfter = '</span>';
        $linkAttr = ' rel="v:url" property="v:title"';
        $link = $linkBefore . '<a' . $linkAttr . ' href="%1$s">%2$s</a>' . $linkAfter;
        if (is_home() || is_front_page()) {
          if ($showOnHome == 1) echo '<div id="crumbs"><a href="' . $homeLink . '">' . $text['home'] . '</a></div>';
        } else {
          echo '<div id="crumbs" xmlns:v="http://rdf.data-vocabulary.org/#">' . sprintf($link, $homeLink, $text['home']) . $delimiter;
          
          if ( is_category() ) {
            $thisCat = get_category(get_query_var('cat'), false);
            if ($thisCat->parent != 0) {
              $cats = get_category_parents($thisCat->parent, TRUE, $delimiter);
              $cats = str_replace('<a', $linkBefore . '<a' . $linkAttr, $cats);
              $cats = str_replace('</a>', '</a>' . $linkAfter, $cats);
              echo $cats;
              echo "string";
            }
            echo $before . sprintf($text['category'], single_cat_title('', false)) . $after;
          } elseif( is_tax() ){
            $thisCat = get_category(get_query_var('cat'), false);
            if ($thisCat->parent != 0) {
              $cats = get_category_parents($thisCat->parent, TRUE, $delimiter);
              $cats = str_replace('<a', $linkBefore . '<a' . $linkAttr, $cats);
              $cats = str_replace('</a>', '</a>' . $linkAfter, $cats);
              echo $cats;
            }
            echo $before . sprintf($text['tax'], single_cat_title('', false)) . $after;
          
          }elseif ( is_search() ) {
            echo $before . sprintf($text['search'], get_search_query()) . $after;
          } elseif ( is_day() ) {
            echo sprintf($link, get_year_link(get_the_time('Y')), get_the_time('Y')) . $delimiter;
            echo sprintf($link, get_month_link(get_the_time('Y'),get_the_time('m')), get_the_time('F')) . $delimiter;
            echo $before . get_the_time('d') . $after;
          } elseif ( is_month() ) {
            echo sprintf($link, get_year_link(get_the_time('Y')), get_the_time('Y')) . $delimiter;
            echo $before . get_the_time('F') . $after;
          } elseif ( is_year() ) {
            echo $before . get_the_time('Y') . $after;
          } elseif ( is_single() && !is_attachment() ) {
            if ( get_post_type() != 'post' ) {
              $post_type = get_post_type_object(get_post_type());
              $slug = $post_type->rewrite;
              printf($link, $homeLink . '/' . $slug['slug'] . '/', $post_type->labels->singular_name);
              if ($showCurrent == 1) echo $delimiter . $before . get_the_title() . $after;
            } else {
              $cat = get_the_category(); $cat = $cat[0];
              $cats = get_category_parents($cat, TRUE, $delimiter);
              if ($showCurrent == 0) $cats = preg_replace("#^(.+)$delimiter$#", "$1", $cats);
              $cats = str_replace('<a', $linkBefore . '<a' . $linkAttr, $cats);
              $cats = str_replace('</a>', '</a>' . $linkAfter, $cats);
              echo $cats;
              if ($showCurrent == 1) echo $before . get_the_title() . $after;
            }
          } elseif ( !is_single() && !is_page() && get_post_type() != 'post' && !is_404() ) {
            $post_type = get_post_type_object(get_post_type());
            echo $before . $post_type->labels->singular_name . $after;
          } elseif ( is_attachment() ) {
            $parent = get_post($post->post_parent);
            $cat = get_the_category($parent->ID); $cat = $cat[0];
            $cats = get_category_parents($cat, TRUE, $delimiter);
            $cats = str_replace('<a', $linkBefore . '<a' . $linkAttr, $cats);
            $cats = str_replace('</a>', '</a>' . $linkAfter, $cats);
            echo $cats;
            printf($link, get_permalink($parent), $parent->post_title);
            if ($showCurrent == 1) echo $delimiter . $before . get_the_title() . $after;
          } elseif ( is_page() && !$post->post_parent ) {
            if ($showCurrent == 1) echo $before . get_the_title() . $after;
          } elseif ( is_page() && $post->post_parent ) {
            $parent_id  = $post->post_parent;
            $breadcrumbs = array();
            while ($parent_id) {
              $page = get_page($parent_id);
              $breadcrumbs[] = sprintf($link, get_permalink($page->ID), get_the_title($page->ID));
              $parent_id  = $page->post_parent;
            }
            $breadcrumbs = array_reverse($breadcrumbs);
            for ($i = 0; $i < count($breadcrumbs); $i++) {
              echo $breadcrumbs[$i];
              if ($i != count($breadcrumbs)-1) echo $delimiter;
            }
            if ($showCurrent == 1) echo $delimiter . $before . get_the_title() . $after;
          } elseif ( is_tag() ) {
            echo $before . sprintf($text['tag'], single_tag_title('', false)) . $after;
            // Début de l'ajout de la recherhce par catalogue
          } elseif ( is_author() ) {
            global $author;
            $userdata = get_userdata($author);
            echo $before . sprintf($text['author'], $userdata->display_name) . $after;
          } elseif ( is_404() ) {
            echo $before . $text['404'] . $after;
          }
          if ( get_query_var('paged') ) {
            if ( is_category() || is_day() || is_month() || is_year() || is_search() || is_tag() || is_author() ) echo ' (';
            echo __('- Page') . ' ' . get_query_var('paged');
            if ( is_category() || is_day() || is_month() || is_year() || is_search() || is_tag() || is_author() ) echo ')';
          }
          echo '</div>';
        }
      } // end dimox_breadcrumbs()








/////////////////////////////////////////////////////////////////////
////////// Customisation de l'Admin
////////////////////////////////////////////////////////////////////


/////////* CUSTOM LOGO */
        function my_login_logo() { ?>
            <style type="text/css">
              #login h1 a, .login h1 a {
                  background-image: url(<?php echo get_template_directory_uri(); ?>/assets/images/logo-databack-RVB.jpg);
                  height: 65px;
                  width: 320px;
                  background-size: cover;
                  background-repeat: no-repeat;
                  padding-bottom: 30px;
                  background-color: white;
                  background-position: 50%;
                  margin-bottom: -17px;
                  box-shadow: 0 1px 3px rgba(0,0,0,.13);
              }
            </style>
        <?php }
        add_action( 'login_enqueue_scripts', 'my_login_logo' );



///////// CUSTOM FOOTER
        function change_admin_footer(){
           echo '<span id="footer-note">DATA PROJEKT</span>';
          }
        add_filter('admin_footer_text', 'change_admin_footer');

///////// ADMIN CSS
        add_action('admin_print_styles', 'admin_css', 11 );
        function admin_css() {
          $admin_handle = 'admin_css';
          $admin_stylesheet = get_template_directory_uri() . '/assets/css/admin.css';
          wp_enqueue_style( $admin_handle, $admin_stylesheet );
        }


///////// Fonction pour couper du texte */
        function myTruncate($string, $limit, $break=".", $pad="...")
        {
          // return with no change if string is shorter than $limit
          if(strlen($string) <= $limit) return $string;

          // is $break present between $limit and the end of the string?
          if(false !== ($breakpoint = strpos($string, $break, $limit))) {
            if($breakpoint < strlen($string) - 1) {
              $string = substr($string, 0, $breakpoint) . $pad;
            }
          }

          return $string;
        }

        add_image_size( '2500', 2500, 1450, false );
        add_image_size( '260', 260, 173, true );
        add_image_size( '1140', 2500, 1450, false );
        add_image_size( 'mobile2x', 720, 1280, true ); // 220 pixels wide by 180 pixels tall, hard crop mode
        add_image_size( 'mobile1x', 360, 640, true ); // 220 pixels wide by 180 pixels tall, hard crop mode


///////// Autoriser les fichiers SVG */
function cc_mime_types($mimes) {
  $mimes['svg'] = 'image/svg+xml';
  return $mimes;
}
add_filter('upload_mimes', 'cc_mime_types');    


/////////////////////////////////////////////////////////////////////
////////// Cusomisation de TinMCE
////////////////////////////////////////////////////////////////////

///////// Custom toolbar WYSIWYG
        add_filter( 'acf/fields/wysiwyg/toolbars' , 'my_toolbars'  );
        function my_toolbars( $toolbars ) {
            // Add a new toolbar called "Very Simple"
            // - this toolbar has only 1 row of buttons
            $toolbars['Very Simple' ] = array();
            $toolbars['Very Simple' ][1] = array('bold' , 'alignleft', 'aligncenter', 'alignright', 'italic' , 'underline', 'bullist',  'numlist', 'link' );

            // Edit the "Full" toolbar and remove 'code'
            // - delet from array code from http://stackoverflow.com/questions/7225070/php-array-delete-by-value-not-key
            if( ($key = array_search('code' , $toolbars['Full' ][2])) !== false ) {
                unset( $toolbars['Full' ][2][$key] );
            }

            // return $toolbars - IMPORTANT!
            return $toolbars;
        }

///////// TINY MCE > Copier coller en TEXT only
        add_filter('tiny_mce_before_init', 'ag_tinymce_paste_as_text');
        function ag_tinymce_paste_as_text( $init ) {
        $init['paste_as_text'] = true;
        return $init;
        }


///////// Modify TinyMCE editor to remove H1.
        add_filter('tiny_mce_before_init', 'tiny_mce_remove_unused_formats' );
        function tiny_mce_remove_unused_formats($init) {
        // Add block format elements you want to show in dropdown
        $init['block_formats'] = 'Paragraph=p;Heading 2=h2;Heading 3=h3;Heading 4=h4;';
        return $init;
        }


/////////////////////////////////////////////////////////////////////
////////// Disable Yoast's Hidden love letter about using the WordPress SEO plugin.
////////////////////////////////////////////////////////////////////

      add_action( 'template_redirect', function () {
       
          if ( ! class_exists( 'WPSEO_Frontend' ) ) {
              return;
          }
       
          $instance = WPSEO_Frontend::get_instance();
       
          // make sure, future version of the plugin does not break our site.
          if ( ! method_exists( $instance, 'debug_mark') ) {
              return ;
          }
       
          // ok, let us remove the love letter.
           remove_action( 'wpseo_head', array( $instance, 'debug_mark' ), 2 );
      }, 9999 );

      /* Remove welcome panel */
      remove_action('welcome_panel', 'wp_welcome_panel');



/////////////////////////////////////////////////////////////////////
////////// AJAX LOAD MORE
////////////////////////////////////////////////////////////////////

       function load_posts_by_ajax_callback() {
        check_ajax_referer('load_more_posts', 'security');
        $paged = $_POST['page'];
        $args = array(
            'post_type' => 'post',
            'post_status' => 'publish',
            'posts_per_page' => '6',
            'paged' => $paged,
        );
        $my_posts = new WP_Query( $args );

        if ( $my_posts->have_posts() ) :
            ?>
            <?php while ( $my_posts->have_posts() ) : $my_posts->the_post(); ?>


            <?php $categorie_ids = get_field( 'categorie' ); ?>

            <div class="newsbox_wrapper _4actu <?php echo esc_html( get_cat_slug( $categorie_ids ) );  ?> mix" style="display:inline-block">
                <a class="newsbox _4slide" href="<?php the_permalink(); ?>">

                    <div class="newsbox_img_wrapper" style="background-color: #dfdfdf">
                        <?php if ( has_post_thumbnail( get_the_ID() ) ) : ?>
                            <?php echo get_the_post_thumbnail( get_the_ID(), 'thumbnail', array( 'class' => 'newsbox_img' ) ); ?>
                        <?php else : ?>
                            <img src="<?php echo get_template_directory_uri(); ?>/images/IMAGE_PLACEHOLDER.jpg" alt="" style="object-fit: contain;height: 100%;margin: 0 auto;display: block;">
                        <?php endif; ?>
                    </div>

                    <div class="newsbox_content">
                        <div class="newsbox_title"><?php the_title(); ?></div>
                        <p class="newsbox_p">
                            <?php
                            echo wp_trim_words( get_the_content(), 20, '...' );
                            ?>
                        </p>
                        <div class="newsbox_linkbox"><span class="newbox_link">Lire la suite</span>
                            <div class="newsbox_subline"></div>
                        </div>
                    </div>
                    
                    <div class="newsbox_category-label"><?php echo get_cat_name( $categorie_ids ) ?></div>
                    
                    
                    
                </a>
            </div>


            <?php endwhile; ?>
            <?php
        endif;

        wp_die();
      }

      add_action('wp_ajax_load_posts_by_ajax', 'load_posts_by_ajax_callback');
      add_action('wp_ajax_nopriv_load_posts_by_ajax', 'load_posts_by_ajax_callback');



/////////////////////////////////////////////////////////////////////
////////// Typographie > Populate fields with other field
////////////////////////////////////////////////////////////////////

      function acf_load_color_field_choices( $field ) {
          
          // reset choices
          $field['choices'] = array();
          
          
          // On récupère les valeurs du field font (checkbox)
          $choices = get_field('font', 'option', false);

          
          // loop through array and add to field 'choices'
          if( is_array($choices) ) {
              
              foreach( $choices as $choice ) {
                  
                  $field['choices'][ $choice ] = $choice;
                  
              }
              
          }
          

          // return the field
          return $field;
          
      }

      // On affecte les valeurs du champ font dans les champs typographie titre / contenu
      add_filter('acf/load_field/name=titre_typography', 'acf_load_color_field_choices'); 
      add_filter('acf/load_field/name=typo_pour_le_contenu', 'acf_load_color_field_choices');



/////////////////////////////////////////////////////////////////////
////////// YOUTUBE PARSE URL
////////////////////////////////////////////////////////////////////
/* Parse the video uri/url to determine the video type/source and the video id */
  function parse_video_uri( $url ) {
    
    // Parse the url 
    $parse = parse_url( $url );
    
    // Set blank variables
    $video_type = '';
    $video_id = '';
    
    // Url is http://youtu.be/xxxx
    if ( $parse['host'] == 'youtu.be' ) {
    
      $video_type = 'youtube';
      
      $video_id = ltrim( $parse['path'],'/' );  
      
    }
    
    // Url is http://www.youtube.com/watch?v=xxxx 
    // or http://www.youtube.com/watch?feature=player_embedded&v=xxx
    // or http://www.youtube.com/embed/xxxx
    if ( ( $parse['host'] == 'youtube.com' ) || ( $parse['host'] == 'www.youtube.com' ) ) {
    
      $video_type = 'youtube';
      
      //parse_str( $parse['query'], $parse['data'] );

      preg_match('%(?:youtube(?:-nocookie)?\.com/(?:[^/]+/.+/|(?:v|e(?:mbed)?)/|.*[?&]v=)|youtu\.be/)([^"&?/ ]{11})%i', $url, $match);
      $video_id = $match[1];

      if ( !empty( $feature ) )
        $video_id = end( explode( 'v=', $parse['query'] ) );
        
      if ( strpos( $parse['path'], 'embed' ) == 1 )
        $video_id = end( explode( '/', $parse['path'] ) );
      
    }
    
    // Url is http://www.vimeo.com
    if ( ( $parse['host'] == 'vimeo.com' ) || ( $parse['host'] == 'www.vimeo.com' ) ) {
    
      $video_type = 'vimeo';
      
      $video_id = ltrim( $parse['path'],'/' );  
            
    }
    $host_names = explode(".", $parse['host'] );
    $rebuild = ( ! empty( $host_names[1] ) ? $host_names[1] : '') . '.' . ( ! empty($host_names[2] ) ? $host_names[2] : '');
    // Url is an oembed url wistia.com
    if ( ( $rebuild == 'wistia.com' ) || ( $rebuild == 'wi.st.com' ) ) {
    
      $video_type = 'wistia';
        
      if ( strpos( $parse['path'], 'medias' ) == 1 )
          $video_id = end( explode( '/', $parse['path'] ) );
    
    }
    
    // If recognised type return video array
    if ( !empty( $video_type ) ) {
    
      $video_array = array(
        'type' => $video_type,
        'id' => $video_id
      );
    
      return $video_array;
      
    } else {
    
      return false;
      
    }
    
  }

add_filter('show_admin_bar', '__return_false');

/////////////////////////////////////////////////////////////////////
////////// REMOVE CALDERA SHORTCODE INSERT
////////////////////////////////////////////////////////////////////
add_action( 'plugins_loaded', function() {
    remove_action( 'media_buttons', array( 'Caldera_Forms_Admin', 'shortcode_insert_button' ), 11 );
}, 15 );


// favicons à uploader
function favicons_callback() {
	require_once(get_template_directory() . '/includes/admin-favicons.php');	
}


/////////////////////////////////////////////////////////////////////
////////// MobileDetect
////////////////////////////////////////////////////////////////////
require_once(get_template_directory() . '/includes/mobiledetect.php');

function md_is_mobile() {

  $detect = new Mobile_Detect;

  if( $detect->isMobile() && !$detect->isTablet() ){
    return true;
  } else {
    return false;
  }

}

//éviter les problemes d'accent dans les noms des fichiers
add_filter('sanitize_file_name', 'remove_accents' );

//CHANGE LABEL OF WP POST
function revcon_change_post_label() {
    global $menu;
    global $submenu;
    $menu[5][0] = 'Actualités';
    $submenu['edit.php'][5][0] = 'Actualités';
    $submenu['edit.php'][10][0] = 'Ajouter';
}
function revcon_change_post_object() {
    global $wp_post_types;
    $labels = &$wp_post_types['post']->labels;
    $labels->name = 'Actualités';
    $labels->singular_name = 'Actualité';
    $labels->search_items = 'Rechercher dans les actualités';
    $labels->add_new_item = 'Ajouter une nouvelle actualité';
}

add_action( 'admin_menu', 'revcon_change_post_label' );
add_action( 'init', 'revcon_change_post_object' );


//Give access caldera to editors
add_filter('caldera_forms_manage_cap', 'change_cf_manage_cap', 10, 2);
function change_cf_manage_cap() {
    return 'edit_pages';
}

//TRANSLATION MENU
function icl_post_languages(){
    $languages = icl_get_languages('skip_missing=0&orderby=code');
    if(!empty($languages)){
        echo '<div class="languages-selector-container">';
        foreach($languages as $l){
            if($l['active']) {
                echo '<a href="'.$l['url'].'" class="language active">';
                echo '<span>'. icl_disp_language($l['code']).' </span>';
                echo '</a>';
            }else{
                echo '<a class="language" href="'.$l['url'].'"><span>'. icl_disp_language($l['code']) .'</span></a>';
            }
        }
        echo '</div>';
    }
}

/*
 * Alters event's archive titles
 */
function tribe_alter_event_archive_titles ( $original_recipe_title, $depth ) {

    // Modify the titles here
    // Some of these include %1$s and %2$s, these will be replaced with relevant dates
    $title_upcoming =   'Événements à venir'; // List View: Upcoming events
    $title_past =       'Événements passés'; // List view: Past events
    $title_range =      'Événements pour %1$s - %2$s'; // List view: range of dates being viewed
    $title_month =      'Événements en %1$s'; // Month View, %1$s = the name of the month
    $title_day =        'Événements le %1$s'; // Day View, %1$s = the day
    $title_all =        'Tous les événements pour %s'; // showing all recurrences of an event, %s = event title
    $title_week =       'Événements pour la semaine du %s'; // Week view

    // Don't modify anything below this unless you know what it does
    global $wp_query;
    $tribe_ecp = Tribe__Events__Main::instance();
    $date_format = apply_filters( 'tribe_events_pro_page_title_date_format', tribe_get_date_format( true ) );

    // Default Title
    $title = $title_upcoming;

    // If there's a date selected in the tribe bar, show the date range of the currently showing events
    if ( isset( $_REQUEST['tribe-bar-date'] ) && $wp_query->have_posts() ) {

        if ( $wp_query->get( 'paged' ) > 1 ) {
            // if we're on page 1, show the selected tribe-bar-date as the first date in the range
            $first_event_date = tribe_get_start_date( $wp_query->posts[0], false );
        } else {
            //otherwise show the start date of the first event in the results
            $first_event_date = tribe_event_format_date( $_REQUEST['tribe-bar-date'], false );
        }

        $last_event_date = tribe_get_end_date( $wp_query->posts[ count( $wp_query->posts ) - 1 ], false );
        $title = sprintf( $title_range, $first_event_date, $last_event_date );
    } elseif ( tribe_is_past() ) {
        $title = $title_past;
    }

    // Month view title
    if ( tribe_is_month() ) {
        $title = sprintf(
            $title_month,
            date_i18n( tribe_get_option( 'monthAndYearFormat', 'F Y' ), strtotime( tribe_get_month_view_date() ) )
        );
    }

    // Day view title
    if ( tribe_is_day() ) {
        $title = sprintf(
            $title_day,
            date_i18n( tribe_get_date_format( true ), strtotime( $wp_query->get( 'start_date' ) ) )
        );
    }

    // All recurrences of an event
    if ( function_exists('tribe_is_showing_all') && tribe_is_showing_all() ) {
        $title = sprintf( $title_all, get_the_title() );
    }

    // Week view title
    if ( function_exists('tribe_is_week') && tribe_is_week() ) {
        $title = sprintf(
            $title_week,
            date_i18n( $date_format, strtotime( tribe_get_first_week_day( $wp_query->get( 'start_date' ) ) ) )
        );
    }

    if ( is_tax( $tribe_ecp->get_event_taxonomy() ) && $depth ) {
        $cat = get_queried_object();
        $title = '<a href="' . esc_url( tribe_get_events_link() ) . '">' . $title . '</a>';
        $title .= ' › ' . $cat->name;
    }

    return $title;
}
add_filter( 'tribe_get_events_title', 'tribe_alter_event_archive_titles', 11, 2 );

//MANAGE PRIVACY PAGE
add_action('map_meta_cap', 'custom_manage_privacy_options', 1, 4);
function custom_manage_privacy_options($caps, $cap, $user_id, $args)
{
    if (!is_user_logged_in()) return $caps;

    $user_meta = get_userdata($user_id);
    if (array_intersect(['editor', 'administrator'], $user_meta->roles)) {
        if ('manage_privacy_options' === $cap) {
            $manage_name = is_multisite() ? 'manage_network' : 'manage_options';
            $caps = array_diff($caps, [ $manage_name ]);
        }
    }
    return $caps;
}